package ss2011.se.dp.ha5;

import static org.junit.Assert.*;
import junit.framework.TestCase;
import org.junit.Before;
import org.junit.Test;
import ss2011.se.dp.ha5.a1.model.Bus;
import ss2011.se.dp.ha5.a1.model.Message;
import ss2011.se.dp.ha5.a1.model.Subscriber;

public class HA5Aufgabe2Test
{

    private Subscriber s0;
    private Subscriber s1;
    private Subscriber s2;

    /**
     * Vervollstaendige dieses Programm:
     * <p/>
     * 1) Implementiere die Datenstruktur. Die Klassen Bus, Message und Subscriber duerfen nur Attribute, Container
     * fuer zu-n-Assoziationen und entsprechende Zugriffsmethoden enthalten (getter/setter fuer einfache Attribute und
     * zu-1-Assoziationen, addFoo(..), removeFoo(..) und getFoos() fuer zu-n-Assoziationen
     *
     * 2) Erweitere die Zugriffsmethoden um PropertyChange-Events. Dazu soll an die Klasse PropertyChangeSupport delegiert werden:
     *      a) add()- und remove()-Methode(n)
     *      b) die Zugriffsmethoden sollen firePropertyChange() mit sinnvollen Parametern aufrufen
     *
     * 3) Schreibe einen PropertyChangeListener (z.B. im init() verwenden), so dass die beiden folgenden Tests
     * erfolgreich sind! ACHTUNG: die Modell-Klassen sollen dafr unverndert bleiben, die Funktionalitaet soll
     * im PropertyChangeListener enthalten sein.
     *
     * Hinweis: ConcurrentModificationException kann z.B. durch Kopieren der Container umgangen werden!
     *
     */

    @Before
    public void init()
    {
        Bus bus = new Bus();
        s0 = new Subscriber(0);
        bus.addSubscriber(s0);
        s1 = new Subscriber(1);
        bus.addSubscriber(s1);
        s2 = new Subscriber(2);
        bus.addSubscriber(s2);

        // TODO add PropertyChangeListener to each Subscriber!
    }


    /**
     * Der PropertyChangeListener soll fr folgende Funktionalitaet sorgen:
     *
     * Sobald eine Message in the outgoing-Assoziation eingefuegt wird, soll sie an die entsprechend gesetzte Zieladresse
     * zugestellt werden und anschliessend vom outgoing entfernt werden. Weiterhin soll die Absender-Adresse in der Message
     * korrekt gesetzt werden.
     */
    @Test
    public void testBusSendWithPropertyChange()
    {
        Message m = new Message();
        m.setToAddress(2);
        m.setContent("Hallo Du!");
        s1.addOutgoingMessage(m);

        assertEquals(1, s2.getIncomingMessages().size());
        Message received = s2.getIncomingMessages().iterator().next();
        assertEquals(m, received);
        assertEquals(0, s1.getOutgoingMessages().size()); // die Nachricht wurde zusgestellt und ist daher aus der Ausgangsliste verschwunden

        assertEquals(1, received.getFromAddress());

    }

    /**
     * Der PropertyChangeListener soll fr folgende Funktionalitaet sorgen:
     *
     * Sobald eine Message OHNE Ziel-Adresse in the outgoing-Assoziation eingefuegt wird, soll sie an alle ANDEREN Teilnehmer
     * zugestellt werden und anschliessend vom outgoing entfernt werden. Weiterhin soll die Absender-Adresse in der Message
     * korrekt gesetzt werden.
     */
    @Test
    public void testBusBroadcastWithPropertyChange()
    {

        Message m = new Message();
        // keine Zieladresse, d.h. sie soll allen Subscribern zugestellt werden
        m.setContent("Hallo ihr alle!!!");

        assertEquals(0, s0.getIncomingMessages().size());
        assertEquals(0, s1.getIncomingMessages().size());
        assertEquals(0, s2.getIncomingMessages().size());

        s0.addOutgoingMessage(m);

        assertEquals(0, s0.getIncomingMessages().size()); // die Nachricht wird nicht an den Absender zugestellt!
        assertEquals(1, s1.getIncomingMessages().size());
        assertEquals(1, s2.getIncomingMessages().size());
        assertEquals(0, s0.getOutgoingMessages().size()); // die Nachricht wurde zusgestellt und ist daher aus der Ausgangsliste verschwunden
    }


}
